<template>
  <div class="skmpay-result container">
    <!-- 交易結果頁 -->
    <steps :steps="step" :stepActive="status === STATUS.SUCCESS ? 3 : 2" />
    <div class="skmpay-result-order">
      <i18n v-if="account" path="account.hi" tag="div" class="greeting">
        <template v-slot:level>
          <span class="account-level">{{ account.levelTitle }}</span>
        </template>
        <template v-slot:name>
          <span class="account-name">{{ account.name }}</span>
        </template>
      </i18n>

      <div v-if="status" class="skmpay-result-status" :class="status">
        {{ $t(`skmpay.${status}`) }}
      </div>
      <div v-else class="skmpay-result-status text-center">
        交易確認中<br class="d-md-none" /><span class="d-none d-md-inline-block"
          >，</span
        >請稍候
      </div>

      <template v-if="status === STATUS.SUCCESS">
        <router-link
          :to="{
            name: 'PreorderRecord',
            params: { orderId: skmpayOrder.id }
          }"
          class="skm-btn skm-primary-btn"
          >{{ $t("skmpay.checkoutOrder") }}</router-link
        >

        <div class="skmpay-result-note">
          {{ $t("skmpay.resultNote") }}
        </div>
      </template>
      <template v-else>
        <div class="py-3"></div>
        <router-link
          v-if="status"
          :to="{ name: 'landing' }"
          class="skm-btn skm-primary-btn"
          >{{ $t("skmpay.backToFoodMap") }}</router-link
        >
      </template>
    </div>

    <div class="py-3"></div>

    <detail
      v-if="status === STATUS.SUCCESS && skmpayOrder.products.length"
      :order="skmpayOrder"
    />
  </div>
</template>

<script>
import moment from "moment";
import { mapState } from "vuex";
import Steps from "@/components/Skmpay/Steps";
import Detail from "@/components/Skmpay/Detail";
import * as Api from "@/api";
import Order from "@/models/order";

const STATUS = {
  SUCCESS: "success",
  FAIL: "fail",
  CANCEL: "cancel"
};

export default {
  name: "SkmPayResult",
  components: {
    Steps,
    Detail
  },
  data() {
    return {
      STATUS,

      status: this.$route.meta.status,
      step: [
        this.$t("skmpay.step.1"),
        this.$t("skmpay.step.2"),
        this.$t("skmpay.step.3")
      ],

      skmpayOrder: {}
    };
  },
  computed: {
    ...mapState("account", ["account"])
  },
  mounted() {
    this.checkOrder(this.$route.query.mOrderUUID);
  },
  methods: {
    checkOrder(mOrderUUID) {
      Api.Order.checkSkmpayCartResult(mOrderUUID)
        .then(data => {
          console.log("checkPay", data);
          if (data.TransResult) {
            this.loadOrder(data.mOrderUUID);
            this.status = STATUS.SUCCESS;
          } else {
            this.status = STATUS.FAIL;
          }
        })
        .catch(err => {
          this.status = STATUS.FAIL;
          console.log(err);
        });
    },
    loadOrder(mOrderUUID) {
      const { data } = Api.Order.getSkmpayCartResult(mOrderUUID)
        .then(data => {
          this.skmpayOrder = new Order(data);
          console.log(this.skmpayOrder);
        })
        .catch(err => {
          console.log(err);
        });
    }
  }
};
</script>

<style lang="scss" scoped>
.skmpay-result {
  &::v-deep {
    .order-dishes {
      max-width: none;
      margin: 0 -10px;
      padding: 16px 32px;
    }
  }
  &-order {
    display: flex;
    justify-content: center;
    align-items: center;
    flex-direction: column;
    background-color: $white;
    min-height: 400px;
    padding: 60px 32px;
    border: 1px $color-sky-grey solid;
    background: $white;
    border-radius: 4px;

    .greeting {
      color: $color-primary-grey;
      margin-bottom: 80px;
    }

    .account {
      &-level {
        color: $color-skm-red;
      }

      &-name {
        color: $color-primary-grey;
      }
    }
  }

  &-status {
    font-size: 45px;
    color: $color-primary-grey;
    font-weight: bold;
    padding: 24px 0 40px;

    &.success {
      color: $color-skm-red;
    }
  }

  &-note {
    padding-top: 80px;
    font-size: 14px;
    color: $color-primary-grey;
    max-width: 370px;
    text-align: center;
  }

  .skm-primary-btn {
    display: flex;
    align-items: center;
    justify-content: center;
    width: 260px;
    height: 50px;
    font-size: 20px;
  }
}
</style>
